/*
 * It's seemed that when fd is redirected to pipe, write system call can't write
 * more than 7168 bytes at one time. but I don't know why ;-P (by M.Ito)
 */
#define	MAXOUT	7168
#if 0
writex68k(fd, buf, cnt)
    int       fd;
    char      *buf;
    unsigned  cnt;
{
    int  ocnt, loopcnt;
    char *obuf;

    obuf = buf;

    loopcnt = cnt / MAXOUT;
    ocnt = cnt % MAXOUT;

    while(loopcnt){
        if (writex68k_buf(fd, obuf, MAXOUT) == -1){
            return -1;
        }
        obuf += MAXOUT;
        loopcnt--;
    }
    if (writex68k_buf(fd, obuf, ocnt) == -1){
        return -1;
    }
    return cnt;
}
writex68k_buf(fd, buf, cnt)
    int       fd;
    char      *buf;
    unsigned  cnt;
{
    unsigned  n;

    while ((n = write(fd, buf, cnt)) != cnt) {
	if (n == -1) {
	    return -1;
	}
	cnt -= n;
	buf += n;
    }
    return cnt;
}
#else
writex68k(fd, buf, cnt)
    int       fd;
    char      *buf;
    unsigned  cnt;
{
    int  ocnt, loopcnt, n, total = 0;
    char *obuf;

    obuf = buf;

    loopcnt = cnt / MAXOUT;
    ocnt = cnt % MAXOUT;

    while(loopcnt){
        if ((n = write(fd, obuf, MAXOUT)) == -1){
            return -1;
        }
        total += n;
        if (n < MAXOUT){
            return total;
        }
        obuf += MAXOUT;
        loopcnt--;
    }
    if ((n = write(fd, obuf, ocnt)) == -1){
        return -1;
    }
    total += n;

    return total;
}
#endif
